// MicroCtrlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DVP7010AEXE.h"
#include "MicroCtrlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern int CurrentDev;

/////////////////////////////////////////////////////////////////////////////
// MicroCtrlDlg dialog


MicroCtrlDlg::MicroCtrlDlg(DVP7010ADLL* DVPDLL, CWnd* pParent /*=NULL*/)
	: CDialog(MicroCtrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(MicroCtrlDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	DVP = DVPDLL;
	AlarmCheck = 0;
	Trigger1check = 0;
	Trigger2check = 0;
	EEAddrvalid = false;
	EEValvalid = false;
	AlarmSetting = new AlarmStruct[10];
}

MicroCtrlDlg::~MicroCtrlDlg()
{
	delete RTCtime;
	delete [] AlarmSetting;
	DVP = NULL;
	delete DVP;
}

void MicroCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MicroCtrlDlg)
	DDX_Control(pDX, IDC_AlarmTypeCOMBO, m_AlarmTypeCombo);
	DDX_Control(pDX, IDC_AlarmCOMBO, m_AlarmCombo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(MicroCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(MicroCtrlDlg)
	ON_BN_CLICKED(IDC_WDTCHECK, OnWdtcheck)
	ON_EN_CHANGE(IDC_WDTEDIT, OnChangeWdtedit)
	ON_BN_CLICKED(IDC_WDTGetBUTTON, OnWDTGetBUTTON)
	ON_BN_CLICKED(IDC_WDTSetBUTTON, OnWDTSetBUTTON)
	ON_BN_CLICKED(IDC_AlarmCHECK, OnAlarmCHECK)
	ON_BN_CLICKED(IDC_Trigger1CHECK, OnTrigger1CHECK)
	ON_BN_CLICKED(IDC_Trigger2CHECK, OnTrigger2CHECK)
	ON_EN_CHANGE(IDC_YearRTCEDIT, OnChangeYearRTCEDIT)
	ON_EN_CHANGE(IDC_MonthRTCEDIT, OnChangeMonthRTCEDIT)
	ON_EN_CHANGE(IDC_DateRTCEDIT, OnChangeDateRTCEDIT)
	ON_EN_CHANGE(IDC_DayRTCEDIT, OnChangeDayRTCEDIT)
	ON_EN_CHANGE(IDC_HourRTCEDIT, OnChangeHourRTCEDIT)
	ON_EN_CHANGE(IDC_MinRTCEDIT, OnChangeMinRTCEDIT)
	ON_EN_CHANGE(IDC_SecRTCEDIT, OnChangeSecRTCEDIT)
	ON_BN_CLICKED(IDC_RTCGetBUTTON, OnRTCGetBUTTON)
	ON_BN_CLICKED(IDC_RTCSetBUTTON, OnRTCSetBUTTON)
	ON_CBN_SELCHANGE(IDC_AlarmCOMBO, OnSelchangeAlarmCOMBO)
	ON_EN_CHANGE(IDC_YearAlarmEDIT, OnChangeYearAlarmEDIT)
	ON_EN_CHANGE(IDC_MonthAlarmEDIT, OnChangeMonthAlarmEDIT)
	ON_EN_CHANGE(IDC_DateAlarmEDIT, OnChangeDateAlarmEDIT)
	ON_EN_CHANGE(IDC_DayAlarmEDIT, OnChangeDayAlarmEDIT)
	ON_EN_CHANGE(IDC_HourAlarmEDIT, OnChangeHourAlarmEDIT)
	ON_EN_CHANGE(IDC_MinAlarmEDIT, OnChangeMinAlarmEDIT)
	ON_BN_CLICKED(IDC_AlarmGetBUTTON, OnAlarmGetBUTTON)
	ON_BN_CLICKED(IDC_AlarmSetBUTTON, OnAlarmSetBUTTON)
	ON_BN_CLICKED(IDC_AlarmEnableCHECK, OnAlarmEnableCHECK)
	ON_CBN_SELCHANGE(IDC_AlarmTypeCOMBO, OnSelchangeAlarmTypeCOMBO)
	ON_BN_CLICKED(IDC_PowerOnTypeBUTTON, OnPowerOnTypeBUTTON)
	ON_EN_CHANGE(IDC_EEADDREDIT, OnChangeEeaddredit)
	ON_EN_CHANGE(IDC_EEVALEDIT, OnChangeEevaledit)
	ON_BN_CLICKED(IDC_EEGetBUTTON, OnEEGetBUTTON)
	ON_BN_CLICKED(IDC_EESetBUTTON, OnEESetBUTTON)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MicroCtrlDlg message handlers

BOOL MicroCtrlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int i;
	CurSelAlarm = 0;
	RTCtime = new TimeStruct;
	DVP->Adv_DVPAPI_GetWDTTimeout(CurrentDev, &enableWDT, &wdtval);
	((CButton*)GetDlgItem(IDC_WDTCHECK))->SetCheck(enableWDT);
	GetDlgItem(IDC_WDTEDIT)->EnableWindow(enableWDT);	
	GetDlgItem(IDC_WDTGetBUTTON)->EnableWindow(enableWDT);		
	char wdtstr[128];
	sprintf(wdtstr, "%d", wdtval);
	SetDlgItemText(IDC_WDTSTATIC, wdtstr);
	char tstr[128];
	BYTE* val;
	DVP->Adv_DVPAPI_GetRTCData(CurrentDev, RTCtime);
	val = (BYTE*)RTCtime;
	for(i=0; i<sizeof(TimeStruct); i++)
	{
		sprintf(tstr, "%d", (int)*(val+i));
		SetDlgItemText(IDC_SecRTCEDIT+i, tstr);
	}
	m_AlarmTypeCombo.SetCurSel(5);
	m_AlarmCombo.SetCurSel(CurSelAlarm);
	DVP->Adv_DVPAPI_GetUCFlag(CurrentDev, &AlarmCheck, &Trigger1check, &Trigger2check);
	((CButton*)GetDlgItem(IDC_AlarmCHECK))->SetCheck(AlarmCheck);
	((CButton*)GetDlgItem(IDC_Trigger1CHECK))->SetCheck(Trigger1check);
	((CButton*)GetDlgItem(IDC_Trigger2CHECK))->SetCheck(Trigger2check);
	for(i=0; i<10; i++)
		DVP->Adv_DVPAPI_GetAlarm(CurrentDev, i, &AlarmSetting[i]);
	val = (BYTE*)(&AlarmSetting[0].AlarmT);
	for(i=1; i<sizeof(TimeStruct); i++)
	{
		sprintf(tstr, "%d", (int)*(val+i));
		SetDlgItemText(IDC_MinAlarmEDIT+i-1, tstr);
	}
	((CButton*)GetDlgItem(IDC_AlarmEnableCHECK))->SetCheck(AlarmSetting[0].enable);
	switch(AlarmSetting[0].type)
	{
		case HOURLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(0);
			break;
		case DAILY_ALARM:
			m_AlarmTypeCombo.SetCurSel(1);
			break;
		case WEEKLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(2);
			break;
		case MONTHLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(3);
			break;
		case YEARLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(4);
			break;
		case ONCE_ALARM:
			m_AlarmTypeCombo.SetCurSel(5);
			break;
	}
	GetDlgItem(IDC_AlarmCOMBO)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmEnableCHECK)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_YearAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_MonthAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_DateAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_DayAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_HourAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_MinAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmGetBUTTON)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(AlarmCheck);
	GetDlgItem(IDC_AlarmTypeCOMBO)->EnableWindow(AlarmCheck);
	return TRUE;  
}

BOOL MicroCtrlDlg::LoadDialog()
{

	return TRUE;
}

void MicroCtrlDlg::OnWdtcheck() 
{
	enableWDT = ((CButton*)GetDlgItem(IDC_WDTCHECK))->GetCheck();
	GetDlgItem(IDC_WDTEDIT)->EnableWindow(enableWDT);	
	GetDlgItem(IDC_WDTGetBUTTON)->EnableWindow(enableWDT);		
	OnChangeWdtedit();
	if (!enableWDT)
	{
		GetDlgItem(IDC_WDTSetBUTTON)->EnableWindow(FALSE);		
		DVP->Adv_DVPAPI_SetWDTTimeout(CurrentDev, 0, wdtval);	
	}
}

void MicroCtrlDlg::OnChangeWdtedit() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_WDTEDIT, val, 128);
	if (val[0]!=NULL)
	{
		wdtval = atoi(val);
		valvalid = ((wdtval>=0)&&(wdtval<=255));
		if (!valvalid)
		{
			MessageBox("0 <= WDT <= 255");
			SetDlgItemText(IDC_WDTEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_WDTSetBUTTON)->EnableWindow(valvalid);		
}

void MicroCtrlDlg::OnWDTGetBUTTON() 
{
	char wdtstr[128];
	int val;
	DVP->Adv_DVPAPI_GetWDTTimeout(CurrentDev, &enableWDT, &val);
	sprintf(wdtstr, "%d", val);
	SetDlgItemText(IDC_WDTSTATIC, wdtstr);
}

void MicroCtrlDlg::OnWDTSetBUTTON() 
{
	DVP->Adv_DVPAPI_SetWDTTimeout(CurrentDev, 1, wdtval);	
}

void MicroCtrlDlg::OnAlarmCHECK() 
{
	AlarmCheck = ((CButton*)GetDlgItem(IDC_AlarmCHECK))->GetCheck();
	DVP->Adv_DVPAPI_SetUCFlag(CurrentDev, AlarmCheck, Trigger1check, Trigger2check);
	GetDlgItem(IDC_AlarmCOMBO)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmEnableCHECK)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_YearAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_MonthAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_DateAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_DayAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_HourAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_MinAlarmEDIT)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmGetBUTTON)->EnableWindow(AlarmCheck);		
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(AlarmCheck);
	GetDlgItem(IDC_AlarmTypeCOMBO)->EnableWindow(AlarmCheck);	
}

void MicroCtrlDlg::OnTrigger1CHECK() 
{
	// TODO: Add your control notification handler code here
	Trigger1check = ((CButton*)GetDlgItem(IDC_Trigger1CHECK))->GetCheck();
	DVP->Adv_DVPAPI_SetUCFlag(CurrentDev, AlarmCheck, Trigger1check, Trigger2check);		
}

void MicroCtrlDlg::OnTrigger2CHECK() 
{
	Trigger2check = ((CButton*)GetDlgItem(IDC_Trigger2CHECK))->GetCheck();
	DVP->Adv_DVPAPI_SetUCFlag(CurrentDev, AlarmCheck, Trigger1check, Trigger2check);	
}

void MicroCtrlDlg::OnChangeYearRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_YearRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->year = atoi(val);
		valvalid = ((RTCtime->year>=0)&&(RTCtime->year<100));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Year <= 99");
			SetDlgItemText(IDC_YearRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeMonthRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_MonthRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->month = atoi(val);
		valvalid = ((RTCtime->month>=0)&&(RTCtime->month<13));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Month <= 12");
			SetDlgItemText(IDC_MonthRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeDateRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_DateRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->date = atoi(val);
		valvalid = ((RTCtime->date>=0)&&(RTCtime->date<32));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Date <= 31");
			SetDlgItemText(IDC_DateRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeDayRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_DayRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->day = atoi(val);
		valvalid = ((RTCtime->day>0)&&(RTCtime->day<8));
		if (!valvalid)
		{
			MessageBox("1 <= RCT Day <= 7");
			SetDlgItemText(IDC_DayRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);		
}

void MicroCtrlDlg::OnChangeHourRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_HourRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->hour = atoi(val);
		valvalid = ((RTCtime->hour>=0)&&(RTCtime->hour<25));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Hour <= 24");
			SetDlgItemText(IDC_HourRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeMinRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_MinRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->minute = atoi(val);
		valvalid = ((RTCtime->minute>=0)&&(RTCtime->minute<60));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Minute <= 59");
			SetDlgItemText(IDC_MinRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);		
}

void MicroCtrlDlg::OnChangeSecRTCEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_SecRTCEDIT, val, 128);
	if (val[0]!=NULL)
	{
		RTCtime->second = atoi(val);
		valvalid = ((RTCtime->second>=0)&&(RTCtime->second<60));
		if (!valvalid)
		{
			MessageBox("0 <= RCT Second <= 59");
			SetDlgItemText(IDC_SecRTCEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_RTCSetBUTTON)->EnableWindow(valvalid);		
}

void MicroCtrlDlg::OnRTCGetBUTTON() 
{
	char tstr[128];
	BYTE* val;
	DVP->Adv_DVPAPI_GetRTCData(CurrentDev, RTCtime);
	val = (BYTE*)RTCtime;
	for(int i=0; i<sizeof(TimeStruct); i++)
	{
		sprintf(tstr, "%d", (int)*(val+i));
		SetDlgItemText(IDC_SecRTCEDIT+i, tstr);
	}		
}

void MicroCtrlDlg::OnRTCSetBUTTON() 
{
	DVP->Adv_DVPAPI_SetRTCData(CurrentDev, RTCtime);
}

void MicroCtrlDlg::OnSelchangeAlarmCOMBO() 
{
	CurSelAlarm = m_AlarmCombo.GetCurSel();
}

void MicroCtrlDlg::OnChangeYearAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_YearAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.year = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.year>=0)&&(AlarmSetting[CurSelAlarm].AlarmT.year<100));
		if (!valvalid)
		{
			MessageBox("0 <= Alarm Year <= 99");
			SetDlgItemText(IDC_YearAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeMonthAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_MonthAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.month = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.month>=0)&&(AlarmSetting[CurSelAlarm].AlarmT.month<13));
		if (!valvalid)
		{
			MessageBox("0 <= Alarm Month <= 12");
			SetDlgItemText(IDC_MonthAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeDateAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_DateAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.date = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.date>=0)&&(AlarmSetting[CurSelAlarm].AlarmT.date<32));
		if (!valvalid)
		{
			MessageBox("0 <= Alarm Date <= 31");
			SetDlgItemText(IDC_DateAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);	
}

void MicroCtrlDlg::OnChangeDayAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_DayAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.day = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.day>0)&&(AlarmSetting[CurSelAlarm].AlarmT.day<8));
		if (!valvalid)
		{
			MessageBox("1 <= Alarm Day <= 7");
			SetDlgItemText(IDC_DayAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);
}

void MicroCtrlDlg::OnChangeHourAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_HourAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.hour = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.hour>=0)&&(AlarmSetting[CurSelAlarm].AlarmT.hour<25));
		if (!valvalid)
		{
			MessageBox("0 <= Alarm Hour <= 24");
			SetDlgItemText(IDC_HourAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);
}

void MicroCtrlDlg::OnChangeMinAlarmEDIT() 
{
	char val[128];
	bool valvalid;
	GetDlgItemText(IDC_MinAlarmEDIT, val, 128);
	if (val[0]!=NULL)
	{
		AlarmSetting[CurSelAlarm].AlarmT.minute = atoi(val);
		valvalid = ((AlarmSetting[CurSelAlarm].AlarmT.minute>=0)&&(AlarmSetting[CurSelAlarm].AlarmT.minute<60));
		if (!valvalid)
		{
			MessageBox("0 <= Alarm Minute <= 59");
			SetDlgItemText(IDC_MinAlarmEDIT, "");
		}
	}
	else
		valvalid = false;
	GetDlgItem(IDC_AlarmSetBUTTON)->EnableWindow(valvalid);
}

void MicroCtrlDlg::OnAlarmGetBUTTON() 
{
	char tstr[128];
	BYTE* val;
	DVP->Adv_DVPAPI_GetAlarm(CurrentDev, CurSelAlarm, &AlarmSetting[CurSelAlarm]);
	val = (BYTE*)(&AlarmSetting[CurSelAlarm].AlarmT);
	for(int i=1; i<sizeof(TimeStruct); i++)
	{
		sprintf(tstr, "%d", (int)*(val+i));
		SetDlgItemText(IDC_MinAlarmEDIT+i-1, tstr);
	}
	((CButton*)GetDlgItem(IDC_AlarmEnableCHECK))->SetCheck(AlarmSetting[CurSelAlarm].enable);
	switch(AlarmSetting[CurSelAlarm].type)
	{
		case HOURLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(0);
			break;
		case DAILY_ALARM:
			m_AlarmTypeCombo.SetCurSel(1);
			break;
		case WEEKLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(2);
			break;
		case MONTHLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(3);
			break;
		case YEARLY_ALARM:
			m_AlarmTypeCombo.SetCurSel(4);
			break;
		case ONCE_ALARM:
			m_AlarmTypeCombo.SetCurSel(5);
			break;
	}
}

void MicroCtrlDlg::OnAlarmSetBUTTON() 
{
	DVP->Adv_DVPAPI_SetAlarm(CurrentDev, CurSelAlarm, &AlarmSetting[CurSelAlarm]);	
}

void MicroCtrlDlg::OnAlarmEnableCHECK() 
{
	AlarmSetting[CurSelAlarm].enable = ((CButton*)GetDlgItem(IDC_AlarmEnableCHECK))->GetCheck();
}

void MicroCtrlDlg::OnSelchangeAlarmTypeCOMBO() 
{
	switch(m_AlarmTypeCombo.GetCurSel())
	{
		case 0:
			AlarmSetting[CurSelAlarm].type = HOURLY_ALARM;
			break;
		case 1:
			AlarmSetting[CurSelAlarm].type = DAILY_ALARM;
			break;
		case 2:
			AlarmSetting[CurSelAlarm].type = WEEKLY_ALARM;
			break;
		case 3:
			AlarmSetting[CurSelAlarm].type = MONTHLY_ALARM;
			break;
		case 4:
			AlarmSetting[CurSelAlarm].type = YEARLY_ALARM;
			break;
		case 5:
			AlarmSetting[CurSelAlarm].type = ONCE_ALARM;
			break;
		default:
			AlarmSetting[CurSelAlarm].type = ONCE_ALARM;
	}
}

void MicroCtrlDlg::OnPowerOnTypeBUTTON() 
{
	POWERON_EVENT event;
	DVP->Adv_DVPAPI_GetPoweronEvent(CurrentDev, &event);
	switch(event)
	{
		case BY_USER:
			SetDlgItemText(IDC_PowerOnSTATIC, "USER");
			break;
		case BY_TRIGGER0:
			SetDlgItemText(IDC_PowerOnSTATIC, "TRIGGER1");
			break;
		case BY_TRIGGER1:
			SetDlgItemText(IDC_PowerOnSTATIC, "TRIGGER2");
			break;
		case BY_ALARM:
			SetDlgItemText(IDC_PowerOnSTATIC, "ALARM");
			break;
	}
}

void MicroCtrlDlg::OnChangeEeaddredit() 
{
	char byteaddr[128];
	int addr;
	GetDlgItemText(IDC_EEADDREDIT, byteaddr, 128);
	if (byteaddr[0]!=NULL)
	{
		addr = atoi(byteaddr);
		EEAddrvalid = ((addr>=0)&&(addr<=127));
		if (!EEAddrvalid)
		{
			MessageBox("0 <= Address <= 127");
			SetDlgItemText(IDC_EEADDREDIT, "");
		}
	}
	else
		EEAddrvalid = false;
	GetDlgItem(IDC_EESetBUTTON)->EnableWindow(EEAddrvalid&&EEValvalid);	
	GetDlgItem(IDC_EEGetBUTTON)->EnableWindow(EEAddrvalid);			
}

void MicroCtrlDlg::OnChangeEevaledit() 
{
	char byteval[128];
	int val;
	GetDlgItemText(IDC_EEVALEDIT, byteval, 128);
	if (byteval[0]!=NULL)
	{
		val = atoi(byteval);
		EEValvalid = ((val>=0)&&(val<=255));
		if (!EEValvalid)
		{
			MessageBox("0 <= Value <= 255");
			SetDlgItemText(IDC_EEVALEDIT, "");
		}
	}
	else
		EEValvalid = false;
	GetDlgItem(IDC_EESetBUTTON)->EnableWindow(EEAddrvalid&&EEValvalid);	
	GetDlgItem(IDC_EEGetBUTTON)->EnableWindow(EEAddrvalid);			
}

void MicroCtrlDlg::OnEEGetBUTTON() 
{
	char byteval[128], byteaddr[128];
	BYTE val, addr;
	GetDlgItemText(IDC_EEADDREDIT, byteaddr, 128);
	GetDlgItemText(IDC_EEVALEDIT, byteval, 128);
	addr = atoi(byteaddr);
	int readEERes = DVP->Adv_DVPAPI_GetEEData(CurrentDev, addr, &val);
	if (readEERes==SUCCEEDED) 
	{	
		sprintf(byteval, "%d", (int)val);
		SetDlgItemText(IDC_EEReadSTATIC, byteval);
	}
	else
		MessageBox("Read EE failed");	
}

void MicroCtrlDlg::OnEESetBUTTON() 
{
	char byteval[128], byteaddr[128];
	BYTE val, addr;
	GetDlgItemText(IDC_EEADDREDIT, byteaddr, 128);
	GetDlgItemText(IDC_EEVALEDIT, byteval, 128);
	val = (BYTE)atoi(byteval);
	addr = (BYTE)atoi(byteaddr);
	int writeEERes = DVP->Adv_DVPAPI_SetEEData(CurrentDev, addr, &val);
	if (writeEERes!=SUCCEEDED) 
		MessageBox("Write EE failed");		
}
