// SensorControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DVP7010AEXE.h"
#include "SensorControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern int CurrentDev;

/////////////////////////////////////////////////////////////////////////////
// SensorControlDlg dialog

SensorControlDlg::SensorControlDlg(DVP7010ADLL* DVPDLL, CWnd* pParent /*=NULL*/)
	: CDialog(SensorControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(SensorControlDlg)
	//}}AFX_DATA_INIT
	DVP = DVPDLL;
}

SensorControlDlg::~SensorControlDlg()
{
	DVP = NULL;
	delete DVP;
}

void SensorControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SensorControlDlg)
	DDX_Control(pDX, IDC_SaturationSLIDER, m_Saturation);
	DDX_Control(pDX, IDC_HueSLIDER, m_Hue);
	DDX_Control(pDX, IDC_ContrastSLIDER, m_Contrast);
	DDX_Control(pDX, IDC_BrightnessSLIDER, m_Brightness);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SensorControlDlg, CDialog)
	//{{AFX_MSG_MAP(SensorControlDlg)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SensorControlDlg message handlers

BOOL SensorControlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	LoadDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  
}

void SensorControlDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UINT SliderID = pScrollBar->GetDlgCtrlID();
	CSliderCtrl* Slider = (CSliderCtrl *)GetDlgItem(SliderID);
	long sliderPos = Slider->GetPos();
	char sliderPoschar[10];
	sprintf(sliderPoschar, "%d", sliderPos);
	switch(SliderID)
	{
		case IDC_BrightnessSLIDER:
			SetDlgItemText(IDC_BrightnessSTATIC, sliderPoschar);
			DVP->Adv_DVPAPI_SetBrightness(CurrentDev, sliderPos);
			break;
		case IDC_HueSLIDER:
			SetDlgItemText(IDC_HueSTATIC, sliderPoschar);
			DVP->Adv_DVPAPI_SetHue(CurrentDev, sliderPos);
			break;
		case IDC_SaturationSLIDER:
			SetDlgItemText(IDC_SaturationSTATIC, sliderPoschar);
			DVP->Adv_DVPAPI_SetSaturation(CurrentDev, sliderPos);
			break;
		case IDC_ContrastSLIDER:
			SetDlgItemText(IDC_ContrastSTATIC, sliderPoschar);
			DVP->Adv_DVPAPI_SetContrast(CurrentDev, sliderPos);
			break;
	}
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


BOOL SensorControlDlg::LoadDialog() 
{
	int init;
	long sliderPos;
	char sliderPoschar[10];
	m_Brightness.SetRange(0, 100);
	m_Contrast.SetRange(0, 100);
	m_Hue.SetRange(0, 100);
	m_Saturation.SetRange(0, 100);

	init = DVP->Adv_DVPAPI_GetBrightness(CurrentDev, &sliderPos);
	GetDlgItem(IDC_BrightnessSLIDER)->EnableWindow(init==SUCCEEDED);
	if (init==SUCCEEDED)
	{
		m_Brightness.SetPos(sliderPos);
		sprintf(sliderPoschar, "%d", sliderPos);
		SetDlgItemText(IDC_BrightnessSTATIC, sliderPoschar);
	}

	init = DVP->Adv_DVPAPI_GetHue(CurrentDev, &sliderPos);
	GetDlgItem(IDC_HueSLIDER)->EnableWindow(init==SUCCEEDED);
	if (init==SUCCEEDED)
	{
		m_Hue.SetPos(sliderPos);
		sprintf(sliderPoschar, "%d", sliderPos);
		SetDlgItemText(IDC_HueSTATIC, sliderPoschar);
	}

	init = DVP->Adv_DVPAPI_GetSaturation(CurrentDev, &sliderPos);
	GetDlgItem(IDC_SaturationSLIDER)->EnableWindow(init==SUCCEEDED);
	if (init==SUCCEEDED)
	{
		m_Saturation.SetPos(sliderPos);
		sprintf(sliderPoschar, "%d", sliderPos);
		SetDlgItemText(IDC_SaturationSTATIC, sliderPoschar);
	}

	init = DVP->Adv_DVPAPI_GetContrast(CurrentDev, &sliderPos);
	GetDlgItem(IDC_ContrastSLIDER)->EnableWindow(init==SUCCEEDED);
	if (init==SUCCEEDED)
	{
		m_Contrast.SetPos(sliderPos);
		sprintf(sliderPoschar, "%d", sliderPos);
		SetDlgItemText(IDC_ContrastSTATIC, sliderPoschar);
	}
	return TRUE;
}
